/*
One of those Weeks Episode 40: Judgement Day
Copyright (c) 2008,2011 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep40
{
	// Adobe Imports
	import flash.display.MovieClip;
	import flash.display.SimpleButton;
	import flash.events.Event;
	import flash.events.MouseEvent;

	// Blazing Games Imports
	import com.blazinggames.ootw.converse.*;

	public class OotW40Conversation
	extends MovieClip
	{
// ***** CONSTANTS **********************************************************

		private static const NEXTWRONG:String = "NEXTWRONG";
		private static const NEXTQUESTION:String = "NEXTQUESTION";
		private static const FIRSTMISTAKE:String = "FirstMistake";
		private static const SECONDMISTAKE:String = "SecondMistake";
		private static const OVER:String = "OVER";
		private static const WIN:String = "WIN";
		private static const TOBECONTINUED:String = "TOBECONTINUED";

// ***** VARIABLES **********************************************************

		protected var _scriptHandler:DefaultScriptCommand;
		protected var _conversation:ConversationHandler;
		protected var _owner:OotW40;
		protected var _questionOrder:Array;
		protected var _currentQuestion:int;
		protected var _wrongCount:int;

// ***** CONSTRUCTOR ********************************************************

		public function OotW40Conversation()
		{
			_questionOrder = new Array();
			_currentQuestion = 0;
			_scriptHandler = new DefaultScriptCommand(true);
			_conversation = new ConversationHandler(speach_movie, _scriptHandler);
			speach_movie.clearDisplay();
			_conversation.addEventListener(Converse.TOPIC_EVENT, topicHandler);
			
			// create the conversation tree.
			var fs:String = "ISFLAGSET TRUE";
			_conversation.addTopic( ConversationHandler.EXIT_TOPIC);

			_conversation.addTopic( new ConversationTopic(
					FIRSTMISTAKE, "Continue...", "How can you not know that about your own Solar System? I ... Judge Soe Srown feels that even sentient races make the occasional mistake so I will let that mistake slide.",
					3,0, fs, null, new Array(NEXTQUESTION)));

			_conversation.addTopic( new ConversationTopic(
					SECONDMISTAKE, "Continue...", "It is clear that you are not aware of your own Solar System and therefore are not a sentient being. Large pets are not allowed on this station so you will have to be put to sleep.",
					3,0, fs, null, new Array(OVER)));

			_conversation.addTopic( new ConversationTopic(
					OVER, "The game is over.", "You are to be put to sleep. Game Over.",
					3,0, fs, null, new Array("Exit")));

			_conversation.addTopic( new ConversationTopic(
					NEXTWRONG, "Continue...", "This text should never be seen", 
					3,0, fs, null, new Array("Exit")));
			_conversation.addTopic( new ConversationTopic(
					NEXTQUESTION, "Continue...", "This text should never be seen", 
					3,0, fs, null, new Array("Exit")));
			_conversation.addTopic( new ConversationTopic(
					TOBECONTINUED, "To be Continued...", "This text should never be seen", 
					3,0, fs, null, new Array("Exit")));

			_conversation.addTopic( new ConversationTopic(
					WIN, "Continue...", "You clearly know your own Solar System so we deem you to be sentient. You will of course have to earn your citizenship but the Professor has already agreed to take you on as lab assistants. Your job will start tomorrow morning.",
					3,0, fs, null, new Array(TOBECONTINUED)));

			// Mercury
			buildQuestion(1, "Which planet is the closest to the Sun?",
					"Mercury", "Venus", "Earth", "Mars",
					"Mercury, a planet named after the messanger to the gods, is the closest to your Sun.");
			buildQuestion(2, "How many Mercury days are there in a Mercury year?",
					"1.5", "42", "88", "365",
					"Due to the 59 Earth Days that a single day on Mercury lasts, there are only 1.5 days in a year.");
			buildQuestion(3, "How many Earth days does it take for Mercury to revolve around the Sun?",
					"88", "66", "77", "99",
					"Being so close to your Sun, Mercury only takes 88 Earth days.");
			
			// Venus
			buildQuestion(4, "Which planet is considered Earth's sister planet?",
					"Venus", "Mercury", "Mars", "Jupiter",
					"Venus has a similar size and composition to Earth.");
			buildQuestion(5, "Which planet is the hottest planet in the inner solar system?",
					"Venus", "Mercury", "Earth", "Mars",
					"Due to the greenhouse effect, Venus is the hottest planet in your inner solar system.");
			buildQuestion(6, "What is the atmosphere of Venus mostly made up of?",
					"Carbon Dioxide", "Oxygen", "Nitrous Oxide", "Hydrogen",
					"Venus has a thick atmosphere made up of Carbon Dioxide.");

			// Earth
			buildQuestion(7, "What is the primary element that makes up the Earth's atmosphere?",
					"Nitrogen", "Oxygen", "Hydrogen", "Helium",
					"Nitrogen makes up the bulk of Earth's atmosphere with only 21% of the atmosphere being Oxygen.");
			buildQuestion(8, "Which planet is the third planet from your Sun?",
					"Earth", "Mercury", "Venus", "Mars",
					"Your home world is the third planet from your Sun.");
			buildQuestion(9, "What is the name of the protoplanet that crashed into Earth forming the moon?",
					"Theia", "Pluto", "Sakura", "Serena",
					"The moon appears to have formed when a protoplanet called Theia crashed into the early Earth.");
					
			// Mars
			buildQuestion(10, "Which planet is the fourth planet from your Sun?",
					"Mars", "Mercury", "Venus", "Earth", 
					"The red planet Mars is the fourth planet from your Sun.");
			buildQuestion(11, "Mars appears red due to what?",
					"Covered with rust", "Covered with red algae", "Covered with Lava", "Atmospheric distortion",
					"Mars reddish color is due to the fine iron oxide (rust) dust that covers the planet.");
			buildQuestion(12, "The tallest mountain in your inner solar system is?",
					"Olympus Mons", "Everest", "Mauna Kea", "Carmack",
					"The Martian Olympus Mons is the tallest mountain.");
					
			// Jupiter
			buildQuestion(13, "What planet is the Fifth planet from your Sun?",
					"Jupiter", "Mars", "Saturn", "Neptune",
					"Jupiter, which some consider a failed Sun, is the fifth planet from your Sun.");
			buildQuestion(14, "How many Earths would fit inside Jupiter?",
					"1,317", "995", "486", "2048",
					"1,317 Earths would fit inside of Jupiter.");
			buildQuestion(15, "What is the great red spot of Jupiter",
					"An Anticyclonic storm", "A cloud of rust", "A large lava flow", "An ocean of vermilion",
					"The famous red spot is an anticyclonic storm that is larger than your Earth.");
			
			// Saturn
			buildQuestion(16, "What planet is the Sixth planet from your Sun?",
					"Saturn", "Jupiter", "Neptune", "Uranus",
					"The sixth planet from the sun is Saturn.");
			buildQuestion(17, "Saturn's rings are made up of what?",
					"Ice and dust", "Diamonds", "Silicon", "Glass",
					"Saturns rings are not actually solid but are made up of a disc of ice crystals with dust and small rocks thrown into the mix.");
			buildQuestion(18, "Density wise, which planet is the lightest?",
					"Saturn", "Jupiter", "Neptune", "Uranus",
					"The lightest planet (density wise) in the solar system is Saturn.");
			
			// Uranus
			buildQuestion(19, "Which planet is the seventh planet from your Sun?",
					"Uranus", "Saturn", "Jupiter", "Neptune",
					"The seventh planet from the sun is Uranus");
			buildQuestion(20, "Which gas/ice giant in your solar system is the smallest?",
					"Uranus", "Saturn", "Jupiter", "Neptune",
					"Uranus is the smallest of the gas giants.");
			buildQuestion(21, "Which planet in your solar system has a sideways tilt?",
					"Uranus", "Saturn", "Jupiter", "Neptune",
					"The Uranus axis of rotation is unique for the solar system as it is tilted sideways.");

			// Neptune
			buildQuestion(22, "Which planet is the eighth planet from your Sun?",
					"Neptune", "Uranus", "Saturn", "Jupiter", 
					"The eighth planet from the sun is Neptune.");
			buildQuestion(23, "The first planet your species discovered by mathematical prediction was?",
					"Neptune", "Uranus", "Saturn", "Jupiter", 
					"The gas giant Neptune was the first planet to be discovered by mathematical prediction rather than observation.");
			buildQuestion(24, "The winds on Neptune reach what speeds?",
					"2100 k/hr", "50 k/hr", "400 k/hr", "1200 k/hr",
					"The winds on Neptune reach the increadible speed of 2100k/hr making this the planet with the strongest winds.");
		}

		private function buildQuestion(num:int, question:String, answer:String,
					wrong1:String, wrong2:String, wrong3:String, reason:String)
		{
			var fs:String = "ISFLAGSET TRUE";
			var questionLabel = "Question" + num;
			var w1Label:String = "wrong" + num + "a";
			var w2Label:String = "wrong" + num + "b";
			var w3Label:String = "wrong" + num + "c";
			var ansLabel:String = "answer" + num;
			var dialogList:Array = new Array(w1Label, w2Label,w3Label,ansLabel);

			scrambleArray(dialogList);
			_questionOrder.push(questionLabel);

			// build result handling topics
			_conversation.addTopic( new ConversationTopic(
					w1Label, wrong1, reason, 
					3,1, fs, null, new Array(NEXTWRONG)));
			_conversation.addTopic( new ConversationTopic(
					w2Label, wrong2, reason,
					3,1, fs, null, new Array(NEXTWRONG)));
			_conversation.addTopic( new ConversationTopic(
					w3Label, wrong3, reason,
					3,1, fs, null, new Array(NEXTWRONG)));
			_conversation.addTopic( new ConversationTopic(
					ansLabel, answer, "That is correct. " + reason,
					3,1, fs, null, new Array(NEXTQUESTION)));
			// now build the question
			_conversation.addTopic( new ConversationTopic(
					questionLabel, questionLabel, question,
					3,1, fs, null, dialogList));
		}

		private function scrambleArray(lst:Array):void
		{
			var swap:int;
			var temp:String;
			
			for (var cntr:int = 0; cntr < lst.length; ++cntr) {
				swap = Math.floor(Math.random() * lst.length);
				temp = lst[cntr];
				lst[cntr] = lst[swap];
				lst[swap] = temp;
			}
		}

// *****

		function topicHandler(event:Event):void {
			var top:ConversationTopic = _conversation.getLastTopic();
			trace(top.topic + "topic was selected");

			if (top.topic == NEXTQUESTION) {
				++_currentQuestion;
				if (_currentQuestion == 12)
					_conversation.showTopic(WIN);
				else
					_conversation.showTopic(_questionOrder[_currentQuestion]);
			} else if (top.topic == NEXTWRONG) {
				++_wrongCount;
				if (_wrongCount > 1)
					_conversation.showTopic(SECONDMISTAKE);
				else
					_conversation.showTopic(FIRSTMISTAKE);
			} else if (top.topic == OVER) {
				_owner.death();
			} else  if (top.topic == TOBECONTINUED) {
				_owner.toScore();
			} else {
				_conversation.showTopic(top.topic);
			}
		}

// ***** Functions - General control ****************************************

		public function startGame(owner:OotW40):void
		{
			_owner = owner;
			scrambleArray(_questionOrder);
			_currentQuestion = 0;
			_wrongCount = 0;
			_conversation.showTopic(_questionOrder[_currentQuestion]);
		}

		public function showTopic(s:String, owner:OotW40)
		{
			_conversation.showTopic(s);
			_owner = owner;
		}
		
		public function getQuestionsAsked():int
		{
			return _currentQuestion;
		}
		
		public function getWrongCount():int
		{
			return _wrongCount;
		}
	} // end class
} // end package

